unit Unit1;

interface

uses
  Windows, Messages, SysUtils,  Classes,graphics,   Forms,
  Dialogs,mmsystem, StdCtrls,shellapi, Controls, Spin, MaxMin, ExtCtrls,
  RXShell, Placemnt;

type
  TArrayBuf = array[0..1023]of byte;//1 KByte
  PArrayBuf = ^TArrayBuf;
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    MinLevel: TSpinEdit;
    MedVLabel: TLabel;
    MaxVLabel: TLabel;
    Panel1: TPanel;
    MedPanel: TPanel;
    Panel2: TPanel;
    MaxPanel: TPanel;
    RxTrayIcon1: TRxTrayIcon;
    FormStorage1: TFormStorage;
    ShowSignal: TCheckBox;
    Label5: TLabel;
    Label6: TLabel;
    DevID: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Label5MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ShowSignalClick(Sender: TObject);
  private
    { Private declarations }
  public
    WaveFormat: TWaveFormatEx;
    WaveIn: PHWaveIn;
    IsOn: boolean;
    Procedure WNDPROC(var msg:TMessage);override;
    Procedure InitWaveIn(einschaltenausschalten:boolean);
    { Public declarations }
  end;
procedure RecordToFile(FileName:string; LP:TStream);

var
  Form1: TForm1;
  LowCounter: Integer=0;
  HighCounter: Integer=0;
  MS: TMemoryStream;
  RecToFile: Boolean=False;
  LCutSize,RCutSize: Integer;

implementation

uses Unit2;

{$R *.dfm}

Procedure Tform1.WNDPROC(var msg:TMessage);
var Hdr: PWaveHdr; i,J,V,AbsV,MaxV,MedV: integer; r: real;
    FName: String; YY,MM,DD,hour,min,sec,msec: WORD;
begin
  INHERITED;
  case msg.Msg of
  MM_WIM_OPEN:
    begin
      MS:=TMemoryStream.Create;
      Button1.Enabled:=false;
      Button2.Enabled:=true;
      Combobox2.Enabled:=false;
      Combobox3.Enabled:=false;
      if ShowSignal.Checked then form2.Show;
      form2.Top:=form1.Top+form1.Height;
    end;
  MM_WIM_CLOSE:
    begin
      Button1.Enabled:=true;
      Button2.Enabled:=false;
      Combobox2.Enabled:=true;
      Combobox3.Enabled:=true;
      form2.Hide;
      MS.Free;
    end;
  MM_WIM_DATA:
    try
      Hdr:=PWaveHdr(msg.LParam);
      if hdr^.dwBytesRecorded>0 then r:=form2.clientWidth/hdr^.dwBytesRecorded //Sonst Teilen durch null
                                else r:=0;
      PatBlt(form2.Canvas.Handle,0,0,form2.ClientWidth,form2.ClientHeight,BLACKNESS);//WHITENESS DSTINVERT DSTCOPY ...
      (* oder form2.canvas.fillrect(form2.canvas.cliprect); *)
      with form2.Canvas do begin
        Pen.Color:=clRed; MoveTo(0,127); LineTo(form2.ClientWidth,127);
        //alle 100 bytes einen dunkelroten Strich
        Pen.Color:=clMaroon;
        for J:=1 to 12 do begin
          MoveTo(round(r*J*100),0); LineTo(round(r*J*100),255);
        end;
        Pen.Color:=clLime;
        MoveTo(0,PArrayBuf(hdr.lpData)^[0]);
        MaxV:=0; MedV:=0;
        for i:=0 to hdr^.dwBytesRecorded-1 do begin
          V:=PArrayBuf(hdr.lpData)^[i]-127;
          AbsV:=Abs(V);
          MaxV:=Max(AbsV,MaxV); Inc(MedV,AbsV);
          lineTo(round(r*i),V+127);
        end;
      end;
      MedV:=Round(MedV/1024);
      MedVLabel.Caption:=IntToStr(MedV);
      MaxVLabel.Caption:=IntToStr(MaxV);
      if MaxV>=MinLevel.Value then begin LowCounter:=0; Inc(HighCounter); end
                              else begin HighCounter:=0; Inc(LowCounter); end;
      if LowCounter=0 then MaxVLabel.Font.Color:=clMaroon
                      else MaxVLabel.Font.Color:=clGreen;
      MedPanel.Height:=Panel1.Height*MedV div 127;
      MaxPanel.Height:=Panel1.Height*MaxV div 127;
      MedPanel.Color:=MedVLabel.Font.Color;
      MaxPanel.Color:=MaxVLabel.Font.Color;
      if (MS<>nil) and not RecToFile then begin
        if (MS.Size>0) or (HighCounter>0) {and (LowCounter>(WaveFormat.nAvgBytesPerSec div 1024))}
          then begin
            MS.WriteBuffer(hdr.lpData^,hdr^.dwBytesRecorded);
            Form1.Color:=clRed;
            Form1.Caption:='WaveRec - Recording';
          end else begin
            Form1.Color:=clBtnFace;
            Form1.Caption:='WaveRec';
          end;
        if (LowCounter>3*(WaveFormat.nAvgBytesPerSec div 1024)) and
           (MS.Size>3.5*WaveFormat.nAvgBytesPerSec) then begin
          if MS.Size>(RCutSize+LCutSize) then begin
            MS.Size:=MS.Size-RCutSize;
            DecodeTime(Now, hour, min, sec, msec);
            DecodeDate(Now, YY, MM, DD);
            FName:=format('%.4u.%.2u.%.2u-%.2u.%.2u.%.2u.wav',[YY,MM,DD,hour,min,sec]);
            RecordToFile(FName,MS);
          end;
          MS.Clear;
        end;
      end;
      WaveInUnprepareHeader(WaveIn^,hdr,Sizeof(TWaveHdr));
      Dispose(hdr.lpData); //Den Speicher vom ArrayBuf befreien
      DisPose(hdr);        //Den Speicher vom WaveHeader befreien
      if isOn=false then EXIT;//wenn es ausgeschaltet wird keine neuen Buffer den Umlauf schicken
      Hdr:=new(PWaveHdr);
      Hdr^.lpData:=pointer(new(PArrayBuf));
      Hdr^.dwBufferLength:=1024;
      Hdr^.dwBytesRecorded:=0;
      Hdr^.dwUser:=0;
      Hdr^.dwFlags:=0;
      Hdr^.dwLoops:=0;
      WaveInPrepareHeader(WaveIn^,Hdr,Sizeof(TWaveHdr));
      WaveInAddBuffer(WaveIn^,hdr,Sizeof(TWaveHdr));
    except
    end;
  end;
end;

Procedure Tform1.InitWaveIn(einschaltenausschalten: boolean);
var i,openError,PrepareError,BufferAddError,StartError: integer;
    WaveHdr: PWaveHdr;
    DaBuffer: PArrayBuf; f: WORD;
begin
  if einschaltenausschalten then begin
    WaveFormat.wFormatTag:=WAVE_FORMAT_PCM;
    WaveFormat.nChannels:=1; //MONO
    WaveFormat.nSamplesPerSec:=strtoint(Combobox2.Text);
    WaveFormat.nAvgBytesPerSec:=strtoint(Combobox2.Text);
    WaveFormat.nBlockAlign:=strtoint(Combobox3.Text);
    WaveFormat.wBitsPerSample:=8;
    WaveIn:=new(PHWaveIn);//Wichtig
    openError:=WaveInOpen(WaveIn,DevID.Value,@WaveFormat,handle,0,CALLBACK_WINDOW);
    for i:=1 to 8 do begin //Schickt acht Buffer in den Umlauf
      DaBuffer:=new(PArrayBuf);//Wichtig
      WaveHdr:=new(PWaveHdr);//Wichtig
      with WaveHdr^ do begin
        lpData:=pointer(DaBuffer);
        dwBufferLength:=sizeof(DaBuffer);//1024 = 1 KByte
        dwBytesRecorded:=0;
        dwUser:=0;
        dwFlags:=0;
        dwLoops:=0;
      end;
      PrepareError:=WaveInPrepareHeader(WaveIn^,WaveHdr,sizeOf(TWaveHdr));
      BufferAddError:=WaveInAddBuffer(WaveIn^,WaveHdr,Sizeof(TWaveHdr));//Schreibt die Header in die "zu Verarbeiten Liste"
    end;
    StartError:=WaveInStart(WaveIn^);//Startet das "Verarbeiten"
    if (openError<>0)or(PrepareError<>0)or(BufferAddError<>0)or(StartError<>0)then
      Showmessage(
       'WaveInOpen :'+inttostr(openError)(*Error 32 = Falsches Format*)+#13+//#13 = Zeilenumbruch
       'WaveInPrepareHeader :'+inttostr(PrepareError)(*Error 5 = Nicht Geffnet*)+#13+
       'WaveInAddBuffer :'+inttostr(BufferAddError)(*Error 5 = Nicht Geffnet*)+#13+
       'StartError :'+inttostr(StartError)(*Error 5 = Nicht Geffnet*)+#13);
  //Die Fehlercodes stehen in der mmsystem.pas
    LCutSize:=Round(0.33*WaveFormat.nAvgBytesPerSec);
    RCutSize:=Round(3.25*WaveFormat.nAvgBytesPerSec);
  end else begin
    WaveInStop(WaveIn^);//Stoppt das "Verarbeiten"
    if WaveIn<>nil then WaveInReset(WaveIn^);
    if WaveIn<>nil then WaveInClose(WaveIn^); //Schliesst den WavePort
    Dispose(WaveIn);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  IsOn:=true;
  InitWaveIn(true);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  IsOn:=false;
  InitWaveIn(false);
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if Button2.Enabled then Button2.Click;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
//  application.HintColor:=clGreen;
//  label5.Caption:='CopyRight by'#13']ChecKeR['#13'ICQ #162210742';
  FormStorage1.RestoreFormPlacement;
  Button1.Click;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//  MS.Free;
end;

procedure TForm1.Label5MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
//  ShellExecute( Application.Handle,'open',pchar('mailto:SendAMail2Me<at>freenet.de?subject=Hab''ne Frage&body='),nil,nil,sw_ShowNormal);
end;

procedure RecordToFile(FileName:string; LP:TStream);
var temp:string;
    i : LongInt;
    T1,T2 : ^byte;
    RecStream: TFileStream;
begin
  if FileName<>'' then try
    RecToFile:=true;
    RecStream:=TFileStream.Create(FileName,fmCreate);
    temp:='RIFF'; RecStream.write(temp[1],length(temp));
    temp:=#0#0#0#0; RecStream.write(temp[1],length(temp));     { File size: to be updated }
    temp:='WAVE'; RecStream.write(temp[1],length(temp));
    temp:='fmt '; RecStream.write(temp[1],length(temp));
    temp:=#$10#0#0#0; RecStream.write(temp[1],length(temp));   { Fixed }
    temp:=#1#0; RecStream.write(temp[1],length(temp));         { PCM format }
    {if FChannels=Mono then} temp:=#1#0
                      {else temp:=#2#0};
    RecStream.write(temp[1],length(temp));
    with form1.WaveFormat do begin
      RecStream.write(nSamplesPerSec,2);
      temp:=#0#0; RecStream.write(temp[1],length(temp));         { SampleRate is given is dWord }
      RecStream.write(nAvgBytesPerSec,4);
      RecStream.write(nBlockAlign,2);
      RecStream.write(wBitsPerSample,2);
    end;
    temp:='data';RecStream.write(temp[1],length(temp));
    temp:=#0#0#0#0;RecStream.write(temp[1],length(temp));    { Data size: to be updated }
    if (LP<>nil) then begin
      LP.Position:=LCutSize;
      RecStream.CopyFrom(LP,LP.Size-LCutSize);
      i:=RecStream.Size-8;    { size of file  }
      RecStream.Position:=4;
      RecStream.write(i,4);
      i:=i-$24;               { size of data   }
      RecStream.Position:=40;
      RecStream.write(i,4);
      RecStream.Free;
      RecToFile:=false;
    end;
  except
  end else
    RecToFile:=false;
end;

procedure TForm1.ShowSignalClick(Sender: TObject);
begin
  if ShowSignal.Checked then begin
    form2.Show;
    if (form1.Top+form1.Height)>450
      then form2.Top:=form1.Top-form2.Height
      else form2.Top:=form1.Top+form1.Height;
  end else form2.Hide;
end;

end.
